;##################################################################
; RegBrowser
;##################################################################

#include "RegBrowser.Inc"

IDD_DLG1	equ		13000
IDR_REGIMAGE equ	21000

DATA SECTION
	hInstance			DD	?
	szBuffer			DB	MAX_PATH DUP ?
	hRegBrowse			DD	?
	hRegTree			DD	?
	hHKEY_CLASSES_ROOT	DD	?
	hHKEY_CURRENT_USER	DD	?
	hHKEY_LOCAL_MACHINE	DD	?
	hRegIml				DD	?

	// Values labels
	szValue1			DB "Name",0
	szValue2			DB "Type",0
	szValue3			DB "Data",0
	szDefault			DB "(Default)",0
	
	// Value types
	ValueType1			DB "REG_BINARY",0
	ValueType2			DB "REG_DWORD",0
	ValueType3			DB "REG_DWORD_BIG_ENDIAN",0
	ValueType4			DB "REG_EXPAND_SZ",0
	ValueType5			DB "REG_LINK",0
	ValueType6			DB "REG_MULTI_SZ",0
	ValueType7			DB "REG_NONE",0
	ValueType8			DB "REG_QWORD",0
	ValueType9			DB "REG_SZ",0
	
	ByteTable			DB	"0123456789ABCDEF",0

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke ImageList_LoadImage,[hInstance], IDR_REGIMAGE,0,0,CLR_NONE,IMAGE_BITMAP,LR_LOADTRANSPARENT
	mov [hRegIml],eax
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR BrowseRegDlg,0
	invoke ImageList_Destroy,[hRegIml]
	invoke ExitProcess,0

BrowseRegistry FRAME hKey,hParent, hTrv
	uses ebx
	LOCAL ftLastWrite	:D
	LOCAL cbKeyName		:D
	LOCAL KeyName[256]	:D

	xor ebx,ebx
	mov [KeyName], ebx
	:
	mov D[cbKeyName], 256
	invoke RegEnumKeyEx,[hKey], ebx,offset KeyName,offset cbKeyName, NULL, NULL, NULL, offset ftLastWrite
	inc ebx
	cmp eax, ERROR_NO_MORE_ITEMS
	je >>
	push eax
	invoke TrvAddNode, [hTrv], [hParent], offset KeyName, 0,0
	pop eax
	cmp eax,ERROR_SUCCESS
	je <<
	:

	RET
ENDF

BrowseKeyValues FRAME hLstVw, hKey
	uses ebx
	LOCAL ValueName[1024]	:B
	LOCAL cbValueName		:D
	LOCAL Type				:D
	LOCAL ValueData[1024]	:B
	LOCAL cbValueData		:D
	
	LOCAL MaxChars			:D
	LOCAL nValues			:D

	LOCAL Garbage			:D

	invoke AddValue,[hLstVw], offset szDefault, REG_SZ, "(value not set)", 16

	xor ebx,ebx
	:
	mov D[cbValueName], 1024
	mov D[cbValueData], 1024
	invoke RegEnumValue, [hKey], ebx, offset ValueName, offset cbValueName, 0, offset Type, offset ValueData, offset cbValueData
	test eax,eax
	jnz >>.DONE
	invoke AddValue,[hLstVw], offset ValueName, [Type], offset ValueData, [cbValueData]
	inc ebx
	jmp <<

	.DONE

	ret
ENDF

BrowseRegDlg FRAME hwnd, uMsg, wParam, lParam
	uses edi,ebx,esi
	LOCAL tvi		:TVITEM
	LOCAL RegKey	:D
	LOCAL phkResult	:D

	.WMNOTIFY
	cmp D[uMsg], WM_NOTIFY
	jne >>.WM_INITDIALOG
		// when a node is double clicked read it's sub keys and open it
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],TVN_SELCHANGED
		jne >>.EXIT
			invoke GetDlgItem, [hwnd], 1001
			mov [hRegTree], eax
			
			invoke GetDlgItem,[hwnd], 1004
			mov esi,eax
			invoke SendMessage,esi,LVM_DELETEALLITEMS,0,0

			mov ebx,[edi+NMTREEVIEW.itemNew+TVITEM.hItem]
			mov [tvi.hItem],ebx
			mov D[tvi.imask],TVIF_TEXT + TVIF_CHILDREN
			mov [tvi.pszText], offset szBuffer
			mov D[tvi.cchTextMax], MAX_PATH-1
			invoke SendMessage,[edi+NMHDR.hwndFrom],TVM_GETITEM,0,ADDR tvi
			mov B[szBuffer],0

			invoke BuildRegKey, [edi+NMHDR.hwndFrom], ebx, offset szBuffer, offset RegKey
			test eax,eax
			js >>.SETVALUES

			mov edx,[tvi.cChildren]
			test edx,edx
			jnz >>.SETVALUES

			invoke RegOpenKeyEx,[RegKey],offset szBuffer, 0,KEY_ALL_ACCESS, offset phkResult
			invoke BrowseRegistry,[phkResult],ebx,[hRegTree]
			invoke RegCloseKey,[phkResult]

			.SETVALUES
			invoke RegOpenKeyEx,[RegKey],offset szBuffer, 0,KEY_ALL_ACCESS, offset phkResult
			invoke BrowseKeyValues, esi, [phkResult]
			invoke RegCloseKey,[phkResult]

		jmp >>.EXIT

	.WM_INITDIALOG
	cmp D[uMsg], WM_INITDIALOG
	jne >>.WMCLOSE
		// Add the 3 primary nodes
		invoke GetDlgItem, [hwnd], 1001
		mov [hRegTree], eax
		
		invoke TrvAddNode, [hRegTree], NULL, "HKEY_CLASSES_ROOT", NULL, HKEY_CLASSES_ROOT
		mov [hHKEY_CLASSES_ROOT], eax
		
		invoke BrowseRegistry,HKEY_CLASSES_ROOT,[hHKEY_CLASSES_ROOT],[hRegTree]
		
		invoke TrvAddNode, [hRegTree], 0, "HKEY_CURRENT_USER", NULL, HKEY_CURRENT_USER
		mov [hHKEY_CURRENT_USER], eax
		
		invoke BrowseRegistry,HKEY_CURRENT_USER,[hHKEY_CURRENT_USER],[hRegTree]
		
		invoke TrvAddNode, [hRegTree], 0, "HKEY_LOCAL_MACHINE", NULL, HKEY_LOCAL_MACHINE
		mov [hHKEY_LOCAL_MACHINE], eax
		
		invoke BrowseRegistry,HKEY_LOCAL_MACHINE,[hHKEY_LOCAL_MACHINE],[hRegTree]
		
		// Set up the values listview
		invoke GetDlgItem,[hwnd],1004
		invoke SetupValuesListView, eax
		
		jmp >.EXIT

	.WMCLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.EXIT
		// End this dialog with that value as a return
		invoke EndDialog,[hwnd],0
		jmp >.EXIT

	.EXIT
	xor eax,eax
	RET
ENDF

BuildRegKey FRAME hTrv, hItem, pRegKeyBuffer, pRegKey
	LOCAL tvi					:TVITEM
	LOCAL hRootItem				:D
	LOCAL dwRegKey				:D
	LOCAL buffer0[MAX_PATH]		:B
	LOCAL buffer1[MAX_PATH]		:B
	LOCAL tvitem				:D

	// This procedure builds a key name from a given item and returns the
	// main key (HKEY) in EAX
	
	// Scan backwards to the root item, there is no simple way to do this
	// TVGN_ROOT only finds the topmost item in the treeview, it does not
	// distinguish between treeview nodes. In order to get the right root
	// we must scan backwards until we reach the top of the treeview
	mov eax,[hItem]
	:
	mov [tvi.hItem],eax
	mov [hRootItem], eax
	invoke SendMessage, [hTrv], TVM_GETNEXTITEM, TVGN_PARENT, eax
	test eax,eax
	jnz <

	mov D[tvi.imask], TVIF_PARAM + TVIF_TEXT
	lea eax, buffer0
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax], MAX_PATH-1
	invoke SendMessage, [hTrv], TVM_GETITEM, 0, offset tvi
	mov eax, [tvi.lParam]
	mov [dwRegKey], eax
	mov ecx,[pRegKey]
	mov [ecx], eax

	; If this is the root item then do not continue, set the return to -1
	xor eax,eax
	dec eax
	mov ecx, [hRootItem]
	cmp ecx,[hItem]
	jne >
		ret
	:

	; Build a key name and store it in the string
	; This has to be done backwards from the last key

	mov eax,[hItem]
	mov [tvitem],eax
	mov [tvi.hItem],eax
	mov D[tvi.imask],TVIF_IMAGE + TVIF_TEXT
	lea eax,buffer1
	add eax,1
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH
	invoke SendMessage,[hTrv],TVM_GETITEM,0,ADDR tvi

	mov B[buffer1],"\"
	:
		invoke SendMessage,[hTrv],TVM_GETNEXTITEM,TVGN_PARENT,[tvitem]
		test eax,eax
		jz >>
		cmp eax,[hRootItem]
		je >>
		mov [tvitem],eax
		mov [tvi.hItem],eax
		mov D[tvi.imask],TVIF_TEXT
		lea eax,buffer0
		add eax,1
		mov B[buffer0],"\"
		mov [tvi.pszText],eax
		mov D[tvi.cchTextMax],MAX_PATH
		invoke SendMessage,[hTrv],TVM_GETITEM,0,ADDR tvi
		invoke szCat,ADDR buffer0,ADDR buffer1
		invoke szCopy,ADDR buffer1,ADDR buffer0
		jmp <<
		:
		lea eax,buffer1
		add eax,1
		invoke szCopy,[pRegKeyBuffer],eax
		xor eax,eax
	.EXIT

	RET
ENDF

SetupValuesListView FRAME hLv
	uses edi,esi
	LOCAL LVColumn		:LV_COLUMN

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szValue1
	mov D[LVColumn.cchTextMax],SIZEOF szValue1
	invoke SendMessage,[hLv],LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szValue2
	mov D[LVColumn.cchTextMax],SIZEOF szValue2
	invoke SendMessage,[hLv],LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szValue3
	mov D[LVColumn.cchTextMax],SIZEOF szValue3
	invoke SendMessage,[hLv],LVM_INSERTCOLUMN,2,ADDR LVColumn

	invoke SendMessage,[hLv],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES + LVS_EX_HEADERDRAGDROP,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT + LVS_EX_HEADERDRAGDROP 

	invoke SendMessage, [hLv], LVM_SETIMAGELIST,LVSIL_SMALL,[hRegIml]

	ret
ENDF

AddValue FRAME hLv,pszName, dwType, pData, cbData
	uses edi,ebx,esi
	LOCAL LVItem		:LV_ITEM
	LOCAL ItemID		:D
	LOCAL szByte		:D
	LOCAL szData[4096]	:B

	invoke SendMessage,[hLv],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov eax,[pszName]
	mov al, [eax]
	test al,al
	jnz >V0
		invoke SendMessage, [hLv], LVM_DELETEITEM,0,0
		mov eax, offset szDefault
		jmp >V1
	V0:
		mov eax, [pszName]
	V1:

	mov [LVItem.pszText],eax
	mov D[LVItem.imask], LVIF_TEXT
	mov D[LVItem.iSubItem],0
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hLv],LVM_INSERTITEM,0,ADDR LVItem
	mov [LVItem.iItem],eax

	mov D[szByte],0
	mov D[szData],0
	cmp D[dwType], REG_BINARY
	jne >>
	xor ebx,ebx
	// Decode the data 1 byte at a time
	mov ecx, [cbData]
	or ecx,ecx
	jz >L2
	js >L2
	mov edi, [pData]
	L1:
		xor eax,eax
		xor edx,edx
		// Split the nibbles
		mov al, [edi]
		mov dl,al
		and dl,00Fh
		and al,0F0h
		shr al,4

		push ecx
		mov cl,[ByteTable+edx]
		mov [szByte],cl
		mov cl,[ByteTable+eax]
		mov [szByte+1],cl
		mov B[szByte+2]," "
		invoke szCat, offset szData, offset szByte
		pop ecx

		inc edi
		add ebx,3
		dec ecx
		or ecx,ecx
		jnz <<L1
		
	L2:
	dec ebx
	mov W[szData+ebx], 0
	lea ebx, szData

	mov eax, offset ValueType1
	mov esi,1
	jmp >>.WRITETYPE

	:
	cmp D[dwType], REG_DWORD
	jne >
	mov ebx,[pData]
	invoke dw2hex,[ebx], offset szData
	lea ebx, szData
	mov eax, offset ValueType2
	mov esi,1
	jmp >>.WRITETYPE
	
	:
	cmp D[dwType], REG_DWORD_BIG_ENDIAN
	jne >
	mov ebx,[pData]
	mov ebx,[ebx]
	bswap ebx
	invoke dw2hex,ebx, offset szData
	lea ebx, szData
	mov eax, offset ValueType3
	mov esi,1
	jmp >>.WRITETYPE
	
	:
	cmp D[dwType], REG_EXPAND_SZ
	jne >
	mov ebx, [pData]
	mov eax, offset ValueType4
	mov esi,0
	jmp >>.WRITETYPE

	:
	cmp D[dwType], REG_LINK
	jne >
	mov ebx, [pData]
	mov eax, offset ValueType5
	mov esi,0
	jmp >.WRITETYPE
	
	:
	cmp D[dwType], REG_MULTI_SZ
	jne >
	mov ebx, [pData]
	mov eax, offset ValueType6
	mov esi,0
	jmp >.WRITETYPE
	
	:
	cmp D[dwType], REG_NONE
	jne >
	mov ebx, [pData]
	mov eax, offset ValueType7
	mov esi,0
	jmp >.WRITETYPE
	
	:
	cmp D[dwType], REG_QWORD
	jne >
	mov ebx, [pData]
	invoke dq2hex, ebx, offset szData
	lea ebx, szData
	mov eax, offset ValueType8
	mov esi,1
	jmp >.WRITETYPE

	:
	cmp D[dwType], REG_SZ
	jne >
	mov ebx, [pData]
	mov eax, offset ValueType9
	mov esi,0
	jmp >.WRITETYPE

	:
	mov eax, offset ValueType7
	mov esi,0

	.WRITETYPE

	mov [LVItem.pszText],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hLv],LVM_SETITEM,0,ADDR LVItem

	mov D[LVItem.iImage],esi
	mov D[LVItem.iSubItem],0
	mov D[LVItem.imask],LVIF_IMAGE
	invoke SendMessage,[hLv],LVM_SETITEM,0,ADDR LVItem

	mov [LVItem.pszText],ebx
	mov D[LVItem.iSubItem],2
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hLv],LVM_SETITEM,0,ADDR LVItem

	RET
ENDF

TrvAddNode FRAME hTrv, hPar, lpPth, nImg, Param
	LOCAL	tvins			:TV_INSERTSTRUCT

	mov eax,[hPar]
	mov [tvins.hParent],eax
	;Saving hPar simplifies building path
	;when user selects an item

	mov eax, [Param]
	mov [tvins.itemex.lParam],eax

	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM + TVIF_IMAGE + TVIF_SELECTEDIMAGE
	mov eax,[lpPth]
	mov [tvins.itemex.pszText],eax
	mov eax,[nImg]
	mov [tvins.itemex.iImage],eax
	mov [tvins.itemex.iSelectedImage],eax
	invoke SendMessage,[hTrv],TVM_INSERTITEM,0,addr tvins

    ret

ENDF

szCat FRAME lpDest,lpAdd
	push edi

	invoke szLen,[lpDest]
	mov edi,[lpDest]
	mov ecx,[lpAdd]
	add edi,eax
	xor edx,edx
	xor eax,eax

	:
		mov al, [ecx+edx]
		mov [edi+edx], al
		add edx, 1
		test al,al
		jne <

	pop edi
	mov eax,[lpDest]

	ret

ENDF

szLen FRAME pString
	uses ebx,edx,ecx,esi

		mov	eax,[pString]
		mov esi,eax
		test eax,3
		jz >N1
			add eax,3
			and eax,-4
ALIGN 4
		:
			mov dl,[esi]
			or dl,dl
			jz >E1
			inc esi
			cmp esi,eax
		jl <

		N1:
		lea		edx,[eax+3]

ALIGN 4
	:  
		mov		ebx,[eax]
		add		eax,4
		lea		ecx,[ebx-01010101h]
		not		ebx
		and		ecx,ebx
		and		ecx,80808080h    
		jz		<
		test	ecx,00008080h
		jnz		>
		shr		ecx,16
		add		eax,2
	:
		shl		cl,1
		sbb		eax,edx

	add eax,esi
	sub eax,[pString]
	ret

	E1:
	mov eax,esi
	sub eax,[pString]
	ret
ENDF

szCopy FRAME pDest,pSource
	uses edi,esi

	mov edi,[pDest]
	mov esi,[pSource]

	test esi,7
	jz >L1
	:
		mov al,[esi]
		mov [edi],al
		or al,al
		jz >D1
		inc esi
		inc edi
		test esi,7
	jne <

	ALIGN 16
	L1:
		mov eax,[esi]
		; Test for 0 byte
		mov edx,eax
		lea ecx,[edx-01010101h]
		not edx
		and ecx,edx
		and ecx,80808080h
		jnz >
		; No 0 byte so copy the dword
		mov [edi],eax
		add esi,4
		add edi,4
		jmp <L1
	:
	; Remainder
	bsf ecx,ecx
	shr ecx,3
	inc ecx
	rep movsb

	lea eax,[edi-1]
	sub eax,[pDest]
	D1:

	RET
ENDF

dq2hex FRAME pValue, lpBuffer
	uses edi

	; Biterider

	mov eax,[pValue]
	mov edx, [eax+4]
	mov ecx, edx
	shr edx, 4
	and edx, 0F0F0F0Fh
	and ecx, 0F0F0F0Fh

	mov eax, edx
	mov edi, ecx

	add edx, 80808080h - 0A0A0A0Ah
	add ecx, 80808080h - 0A0A0A0Ah 
	shr edx, 4          
	shr ecx, 4 
	not edx
	not ecx
	and edx, 07070707h
	and ecx, 07070707h
	add edx, eax
	add ecx, edi
	add edx, 30303030h
	add ecx, 30303030h

	mov edi, [lpBuffer]
	mov B[edi + 7], cl
	mov B[edi + 6], dl
	mov B[edi + 5], ch
	mov B[edi + 4], dh
	shr ecx, 16
	shr edx, 16
	mov B[edi + 3], cl
	mov B[edi + 2], dl
	mov B[edi + 1], ch
	mov B[edi + 0], dh
	mov B[edi + 8], 0

;

	mov eax,[pValue]
	mov edx, [eax]
	mov ecx, edx
	shr edx, 4
	and edx, 0F0F0F0Fh
	and ecx, 0F0F0F0Fh

	mov eax, edx
	mov edi, ecx

	add edx, 80808080h - 0A0A0A0Ah
	add ecx, 80808080h - 0A0A0A0Ah 
	shr edx, 4          
	shr ecx, 4 
	not edx
	not ecx
	and edx, 07070707h
	and ecx, 07070707h
	add edx, eax
	add ecx, edi
	add edx, 30303030h
	add ecx, 30303030h

	mov edi, [lpBuffer]
	add edi,8
	mov B[edi + 7], cl
	mov B[edi + 6], dl
	mov B[edi + 5], ch
	mov B[edi + 4], dh
	shr ecx, 16
	shr edx, 16
	mov B[edi + 3], cl
	mov B[edi + 2], dl
	mov B[edi + 1], ch
	mov B[edi + 0], dh
	mov B[edi + 8], 0

  ret
ENDF

dw2hex FRAME dwValue, lpBuffer
	uses edi

	; Biterider

	mov edx, [dwValue]
	mov ecx, edx
	shr edx, 4
	and edx, 0F0F0F0Fh
	and ecx, 0F0F0F0Fh

	mov eax, edx
	mov edi, ecx

	add edx, 80808080h - 0A0A0A0Ah
	add ecx, 80808080h - 0A0A0A0Ah 
	shr edx, 4          
	shr ecx, 4 
	not edx
	not ecx
	and edx, 07070707h
	and ecx, 07070707h
	add edx, eax
	add ecx, edi
	add edx, 30303030h
	add ecx, 30303030h

	mov edi, [lpBuffer]
	mov B[edi + 7], cl
	mov B[edi + 6], dl
	mov B[edi + 5], ch
	mov B[edi + 4], dh
	shr ecx, 16
	shr edx, 16
	mov B[edi + 3], cl
	mov B[edi + 2], dl
	mov B[edi + 1], ch
	mov B[edi + 0], dh
	mov B[edi + 8], 0

  ret
ENDF
